{
  GeoGet 2
  www: http://geoget.ararat.cz/doku.php/user:skript:cachebox
  autor: mikrom, http://mikrom.cz
  
  * exportuje 5logu
  * poznamku
  * nastavuje mysterce souradnice finale pokud obsahuje final wpt
  * k nazvu pridava hodnoceni v %
  *
  * v1.0 - uvodni verze
  * v1.1 - upraveno do GIP
}

function ExportExtension: string;
begin
  result := 'GPX';
end;

function ExportDescription: string;
begin
  result := 'export pro cachebox (final)';
end;

function ExportHeader: string;
begin
  Result := '<?xml version="1.0" encoding="utf-8"?>' + CRLF;
  Result := Result + '<gpx xmlns:xsd="http://www.w3.org/2001/XMLSchema"'
    + ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0"'
    + ' creator="Groundspeak Pocket Query"'
    + ' xsi:schemaLocation="http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd'
    + ' http://www.groundspeak.com/cache/1/0 http://www.groundspeak.com/cache/1/0/cache.xsd"'
    + ' xmlns="http://www.topografix.com/GPX/1/0">' + CRLF;
  Result := Result + ' <desc>Geocache file generated by GeoGet</desc>' + CRLF;
  Result := Result + ' <author>' + Geoget_Version + '</author>' + CRLF;
  Result := Result + ' <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', now) + '</time>' + CRLF;
  Result := Result + ' <keywords>cache, geocache, groundspeak</keywords>' + CRLF + CRLF;
end;

function ExportFooter: string;
begin
  result := '</gpx>' + CRLF;
end;

function ExportPoint: string;
var
  s: string;
  n: integer;
  finalName: string;
  descr, poznamka, hodnoceni: string;
  GCLogsCount: integer;
  
begin
  Result := '';
  //Export for Geocaches
  if GC.IsListed then
  begin
    if GC.TagValues('Hodnoceni') <> '' then
      hodnoceni := ' ' + GC.TagValues('Hodnoceni')
    else
      hodnoceni := '';

    if GC.HaveFinal then
      finalName := 'FI: ' + GC.Name + hodnoceni + ' (' + GC.FinalWpt.Name + ')'
    else
      finalName := GC.Name + hodnoceni;
        
    Result := Result + ' <wpt lat="' + GC.CorrectedLat + '" lon="' + GC.CorrectedLon + '">' + CRLF;
    Result := Result + '  <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
    Result := Result + '  <name>' + GC.ID +'</name>' + CRLF;
    Result := Result + '  <desc>' + cdata(finalName + ' by ' + GC.Author + ' (' + GC.Difficulty + '/' + GC.Terrain + ')') +'</desc>' + CRLF;
    Result := Result + '  <url>' + GC.URL +'</url>' + CRLF;
    Result := Result + '  <urlname>' + cdata(finalName + ' by ' + GC.Author) + '</urlname>' + CRLF;
    
    if GC.IsFound then
      Result := Result + '  <sym>Geocache Found</sym>' + CRLF
    else
      Result := Result + '  <sym>Geocache</sym>' + CRLF;
      
    Result := Result + '  <type>Geocache|' + GC.CacheType + '</type>' + CRLF;

    if GC.IsDisabled then
      s := 'available="False"'
    else
      s := 'available="True"';
      
    if GC.IsArchived then
      s := s + ' archived="True"'
    else
      s := s + ' archived="False"';
      
    s := 'id="' + GC.CacheID +'" ' + s;
    Result := Result + '  <groundspeak:cache ' + s + ' xmlns:groundspeak="http://www.groundspeak.com/cache/1/0">' + CRLF;
    Result := Result + '   <groundspeak:name>' + cdata(finalName) + '</groundspeak:name>' + CRLF;
    
    if GC.Author = Geoget_Owner then
      Result := Result + '   <groundspeak:placed_by>' + GC.Author +'</groundspeak:placed_by>' + CRLF
    else
      Result := Result + '   <groundspeak:placed_by>' + cdata(GC.Author) +'</groundspeak:placed_by>' + CRLF;
    
    if (GC.OwnerID <> '') and (GC.Author = Geoget_Owner) then
      Result := Result + '   <groundspeak:owner id="' + GC.OwnerID + '">' + GC.Author +'</groundspeak:owner>' + CRLF
    else if GC.OwnerID <> '' then
      Result := Result + '   <groundspeak:owner id="' + GC.OwnerID + '">' + cdata(GC.Author) +'</groundspeak:owner>' + CRLF;

    Result := Result + '   <groundspeak:type>' + GC.CacheType +'</groundspeak:type>' + CRLF;
    Result := Result + '   <groundspeak:container>' + GC.Size +'</groundspeak:container>' + CRLF;
    Result := Result + '   <groundspeak:difficulty>' + GC.Difficulty +'</groundspeak:difficulty>' + CRLF;
    Result := Result + '   <groundspeak:terrain>' + GC.Terrain +'</groundspeak:terrain>' + CRLF;
    Result := Result + '   <groundspeak:country>' + GC.Country +'</groundspeak:country>' + CRLF;
    Result := Result + '   <groundspeak:state>' + GC.State +'</groundspeak:state>' + CRLF;      
    Result := Result + '   <groundspeak:short_description html="True">' + cdata(poznamka + GC.ShortDescription) +'</groundspeak:short_description>' + CRLF;    descr := '';
    
    if GC.HaveFinal then
    begin
      if GC.FinalWpt.Description <> '' then
        descr := descr + '<font color="red">FI Descr: ' + GC.FinalWpt.Description + '</font><br>' + CRLF;
      if GC.FinalWpt.Comment <> '' then
        descr := descr + '<font color="red">FI Comment: ' + GC.FinalWpt.Comment + '</font><br>' + CRLF;
    end;
    
    if GC.Comment <> '' then
      poznamka := '<table border="0" id="table1" width="100%" bgcolor="#E1E1FF"><tr><td><font face="Verdana" size="2"><b>Poznamka:</b><br><i>' + ReplaceString(GC.Comment, CRLF, '<br>') + '</i></font></td></tr></table><br>' + CRLF;
      
    descr := descr + poznamka + CRLF + GC.LongDescription;
    Result := Result + '   <groundspeak:long_description html="True">' + cdata(descr) +'</groundspeak:long_description>' + CRLF;
    
    Result := Result + '   <groundspeak:encoded_hints>' + cdata(GC.Hint) +'</groundspeak:encoded_hints>' + CRLF;
    Result := Result + '   <groundspeak:logs>' + CRLF;
    
    // chceme jen max 5 logu
    if GC.Logs.Count > 5 then
      GCLogsCount := 5
    else
      GCLogsCount := Gc.Logs.Count; 
    for n := 0 to GCLogsCount - 1 do
    begin
      Result := Result + '    <groundspeak:log id="' + GC.Logs[n].LogID + '">' + CRLF;
      Result := Result + '     <groundspeak:date>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Logs[n].Date) + '</groundspeak:date>' + CRLF;
      Result := Result + '     <groundspeak:type>' + GC.Logs[n].LogType + '</groundspeak:type>' + CRLF;

      s := '';
      if GC.Logs[n].FinderID <> '' then
        s := ' id="' + GC.Logs[n].FinderID + '"'; 

      Result := Result + '     <groundspeak:finder' + s + '>' + cdata(GC.Logs[n].Finder) + '</groundspeak:finder>' + CRLF;
      Result := Result + '     <groundspeak:text encoded="False">' + cdata(Html2Text(GC.Logs[n].Text)) + '</groundspeak:text>' + CRLF;
      Result := Result + '    </groundspeak:log>' + CRLF;
    end;
    Result := Result + '   </groundspeak:logs>' + CRLF;
    Result := Result + '  </groundspeak:cache>' + CRLF;
    Result := Result + ' </wpt>' + CRLF + CRLF;
  end;
  //Export for Waypoints
  for n := 0 to GC.Waypoints.Count - 1 do
    if GC.Waypoints[n].IsListed then
    begin
      if GC.Waypoints[n].IsFinal then
        Result := Result + ' <wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF
      else
        Result := Result + ' <wpt lat="' + GC.Waypoints[n].Lat + '" lon="' + GC.Waypoints[n].Lon + '">' + CRLF;
        
      Result := Result + '  <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;

      if GC.Waypoints[n].IsFinal then
        Result := Result + '  <name>' + GC.ID +'</name>' + CRLF
      else
        Result := Result + '  <name>' + GC.Waypoints[n].ID +'</name>' + CRLF;

      Result := Result + '  <cmt>' + cdata(UtfToAscii(GC.Waypoints[n].Description)) +'</cmt>' + CRLF;

      if GC.Waypoints[n].IsFinal then
        Result := Result + '  <desc>Original Location</desc>' + CRLF
      else
        Result := Result + '  <desc>' + cdata(UtfToAscii(GC.Waypoints[n].Name)) +'</desc>' + CRLF;

      Result := Result + '  <url>' + GC.Waypoints[n].URL +'</url>' + CRLF;
      Result := Result + '  <urlname>' + cdata(UtfToAscii(GC.Waypoints[n].Name)) + '</urlname>' + CRLF;

      if GC.Waypoints[n].IsFinal then
      begin
        Result := Result + '  <sym>Reference Point</sym>' + CRLF;
        Result := Result + '  <type>Waypoint|Reference Point</type>' + CRLF;
      end
      else
      begin
        Result := Result + '  <sym>' + GC.Waypoints[n].WptType + '</sym>' + CRLF;
        Result := Result + '  <type>Waypoint|' + GC.Waypoints[n].WptType + '</type>' + CRLF;
      end;
      
      Result := Result + ' </wpt>' + CRLF + CRLF;
    end;
end;
